import bjbupack.jdb.*;  
import java.sql.*;  
import java.util.*;  
/**  
	* Klassen til hndtering af Ansat-Objekter i relationel database  
  * @version  Januar 2002
	* @author	 	DBObjectAdministratorGenerator  
*/  

public class AnsatAdministrator	extends DBObjectAdministrator  
{  
	private 	int 	lastKey 	= 0; 		// gemmer til autonummerering 
	public	AnsatAdministrator (DBAdministrator		dbAdministrator,   
															String table)  
	{  
		super (dbAdministrator, table, "ID","SELECT * FROM "+table);  
		lastKey = getLastKey();		// gemmer til autonummerering  
	}  

	// get-metode med to ngler disables, da objekt er med enkeltngle
	public 	Object 	get 	(int key, int key2)
	{
		System.out.println("Fejl: der skal anvendes metode med eet nglerfelt");
		throw new UnsupportedOperationException();
	}

	// opretter et nyt object p databasen - implementer abstract  
	public 		boolean		add ( Object object )  
	{  
		Ansat 	ansat = (Ansat)object;  
		String sql 	= "INSERT INTO "+table  
								+ " ("  
								+ "  [ID]"  
								+ "  ,[Navn]"  
								+ "  ,[AfdID]"  
								+ " ) VALUES "  
								+ " ("  
								+ "  "	+ansat.getID()			+""  
								+ ", '"	+ansat.getNavn()			+"'"  
								+ ", "	+ansat.getAfdID()			+""  
								+ " )";  
		return ( executeUpdate (sql) );  
	}  

	// opdaterer et eksisterede object p databasen - implementer abstract  
	public 		boolean		replace ( Object object )  
	{  
		Ansat 	ansat = (Ansat)object;  
		String sql	= "UPDATE "+table+" SET"  
								+ "  [Navn]='"	+ansat.getNavn()		+"'"  
								+ ", [AfdID]="	+ansat.getAfdID()		+""  
								+ " WHERE [ID]="	+ansat.getID()		+""  
								;  
		return ( executeUpdate (sql) );  
	}  

	// sletter et object fra dabasen - implementer abstract  
	public 		boolean		remove ( Object object )  
	{  
		Ansat 	ansat = (Ansat)object;  
		String sql	= "DELETE * FROM "+table  
								+ " WHERE [ID]="	+ansat.getID()		+""  
								;  
		return ( executeUpdate (sql) );  
	}  

	// Konverter fra ResultSet til object - implementer abstract  
	protected Object	convertToObject (ResultSet resultSet)  
	{  
		try  
		{  
			Ansat 	ansat = new Ansat ( 	resultSet.getInt("ID"),  
																	 resultSet.getString("Navn"),  
																	 resultSet.getInt("AfdID") 	); 
			return (ansat);  
		}  
		catch (SQLException e)		  
		{  
			System.out.println("Fejl ved convertToObject fra "+table);
			return (null);  
		}  
	}  

	// returner et nyt object - skal gemmes p databasen med add  
	public 		Ansat		newAnsat ( String  navn, int  afdID )
	{  
		++lastKey;  
		Ansat ansat = new Ansat (lastKey, navn, afdID);  
		return (ansat);  
	}  


}  