import bjbupack.jdb.*;  
import java.sql.*;  
import java.util.*;  
/**  
	* Klassen til aftestning af klasser med associering (n-n)
  * @version  Februar 2003
	* @author	 	Bjrk Boye Busch
*/  

public	class Application
{

	public static void main (String[] args)
	{
		
		AnsatAdministrator  			ansatAdm  		= GlobalModel.getAnsatAdministrator();
		ProjektAdministrator			projektAdm		= GlobalModel.getProjektAdministrator();
		ArbejderPaaAdministrator	arbPaaAdm			= GlobalModel.getArbejderPaaAdministrator();		
		
		{ // forbindelse fra ansatte til projekter via arbejderPaa     (n-forbindelse)
      System.out.println("Oversigt over ansatte met tilknyttede projekter");
      Iterator  ansatAllIt = ansatAdm.iterator();
      while (ansatAllIt.hasNext())
      {
	      Ansat 		ansat	= (Ansat) ansatAllIt.next();
	      System.out.println (ansat.getNavn());
	      // udvlg tilhrende arbejderPaa
	      Iterator  arbPaaFilterIt = arbPaaAdm.iterator("WHERE [AnsatID]=" + ansat.getID() );
	      while (arbPaaFilterIt.hasNext())
	      {
		      ArbejderPaa  			arbPaa 		= (ArbejderPaa) arbPaaFilterIt.next();
		      Projekt						projekt		= (Projekt) projektAdm.get ( arbPaa.getProjektID() );
		      System.out.println ( " - " + projekt.getBetegnelse() ); 
	      }		
      }		
		}			
		
    { // forbindelse fra ansatte til projekter via arbejderPaa     (n-forbindelse)
      System.out.println("Oversigt over ansatte met tilknyttede projekter - den pne lsning");
      Iterator  ansatAllIt = ansatAdm.iterator();
      while (ansatAllIt.hasNext())
      {
        Ansat 		ansat	= (Ansat) ansatAllIt.next();
        System.out.println (ansat.getNavn());
        // udvlg tilhrende projekter
        Iterator  projektIt = arbPaaAdm.ProjektAssocieretIterator(ansat);
        while (projektIt.hasNext())
        {
          Projekt  projekt  = (Projekt) projektIt.next();
          System.out.println ( " - " + projekt.getBetegnelse() ); 
        }		
      }		
    }
    
    { // Find person
      Iterator  ansatValgIt = ansatAdm.iterator("WHERE [Navn] like 'Bo' ");
      if (ansatValgIt.hasNext())
      {
        Ansat 		ansat	= (Ansat) ansatValgIt.next();
        // Find projekter		
        Iterator  projektValgIt = projektAdm.iterator("WHERE [Betegnelse] like 'OOP' ");
        if (projektValgIt.hasNext())
        {
          Projekt 		projekt	= (Projekt) projektValgIt.next();
          // Associer ansat til projekt		
          ArbejderPaa  arbPaa =  arbPaaAdm.newArbejderPaa( ansat, projekt );
          arbPaaAdm.add (arbPaa);
        }			
      }			
    }
		
		GlobalModel.close();
	}
}