import bjbupack.jdb.*;  
import java.sql.*;  
import java.util.*;  
/**  
	* Klassen til hndtering af ArbejderPaa-Objekter i relationel database  
  * @version  Januar 2002 / Tilretter Februar 2003 af Bjrk Busch
	* @author	 	DBObjectAdministratorGenerator  
*/  

public class ArbejderPaaAdministrator	extends DBObjectAdministrator  
{  
	public	ArbejderPaaAdministrator (DBAdministrator		dbAdministrator,   
															String table)  
	{  
		super (dbAdministrator, table, "AnsatID","ProjektID","SELECT * FROM "+table);  
	}  

	// get-metode med een ngle disables, da objekt er med dobbeltngle
	public 	Object 	get 	(int key)
	{
		System.out.println("Fejl: der skal anvendes metode med to nglerfelter/IDs (dobbelkey)");
		throw new UnsupportedOperationException();
	}

	// opretter et nyt object p databasen - implementer abstract  
	public 		boolean		add ( Object object )  
	{  
		ArbejderPaa 	arbejderPaa = (ArbejderPaa)object;  
		String sql 	= "INSERT INTO "+table  
								+ " ("  
								+ "  [AnsatID]"  
								+ "  ,[ProjektID]"  
								+ " ) VALUES "  
								+ " ("  
								+ "  "	+arbejderPaa.getAnsatID()			+""  
								+ ", "	+arbejderPaa.getProjektID()			+""  
								+ " )";  
		return ( executeUpdate (sql) );  
	}  

	// opdaterer et eksisterede object p databasen - implementer abstract  
	public 		boolean		replace ( Object object )  
	{  
		ArbejderPaa 	arbejderPaa = (ArbejderPaa)object;  
		String sql	= "UPDATE "+table+" SET"  
								+ " WHERE [AnsatID]="	+arbejderPaa.getAnsatID()		+""  
								+ "   AND [ProjektID]="	+arbejderPaa.getProjektID()		+""  
								;  
		return ( executeUpdate (sql) );  
	}  

	// sletter et object fra dabasen - implementer abstract  
	public 		boolean		remove ( Object object )  
	{  
		ArbejderPaa 	arbejderPaa = (ArbejderPaa)object;  
		String sql	= "DELETE * FROM "+table  
								+ " WHERE [AnsatID]="	+arbejderPaa.getAnsatID()		+""  
								+ "   AND [ProjektID]="	+arbejderPaa.getProjektID()		+""  
								;  
		return ( executeUpdate (sql) );  
	}  

	// Konverter fra ResultSet til object - implementer abstract  
	protected Object	convertToObject (ResultSet resultSet)  
	{  
		try  
		{  
			ArbejderPaa 	arbejderPaa = new ArbejderPaa ( 	resultSet.getInt("AnsatID"),  
																	 resultSet.getInt("ProjektID") 	); 
			return (arbejderPaa);  
		}  
		catch (SQLException e)		  
		{  
			System.out.println("Fejl ved convertToObject fra "+table);
			return (null);  
		}  
	}  

	// returner et nyt object - skal gemmes p databasen med add
  // Tilrettet s objekter og ikke ID'er overfres  
	public 		ArbejderPaa		newArbejderPaa (Ansat ansat, Projekt projekt)  
	{  
		ArbejderPaa arbejderPaa = new ArbejderPaa (ansat.getID(), projekt.getID());  
		return (arbejderPaa);  
	}  


  //---------------------------------------------------------------------------
  // Ekstra metoder
  //---------------------------------------------------------------------------
  public  Iterator AnsatAssocieretIterator (Projekt projekt)
  {
    Iterator arbejderPaaIterator = iterator("WHERE [ProjektID]="+projekt.getID());
    return new AnsatteArbejderPaaIterator (arbejderPaaIterator);
  }
  public  Iterator ProjektAssocieretIterator (Ansat ansat)
  {
    Iterator arbejderPaaIterator = iterator("WHERE [AnsatID]="+ansat.getID());
    return new AnsatteArbejderPaaIterator (arbejderPaaIterator);
  }

}  