import bjbupack.jdb.*;
import java.sql.*;
import java.util.*;
/**  
  * Klassen anvendes til at sikre global tilgang til AssndbDataAdministrator og hermed modelkomponenten  
  * Klassen giver samtidig et singleton-mnster, der sikre at der kun er et objekt.
  * @version  Januar 2002
  * @author   Bjrk Busch
*/  

public class GlobalModel
{
  private static AssndbDataAdministrator AssndbDataAdministrator = new AssndbDataAdministrator();
  private static AssndbDataAdministrator getAssndbDataAdministrator ()
  {
    return (AssndbDataAdministrator);
  }

  // Anvendes til klargring af modelkomponenten
  public  static  void  open ()
  {
    getAssndbDataAdministrator().open();
  }

  // sikrer endelig tilbageskrivning af modelkomponenten
  public  static  void  close ()
  {
    getAssndbDataAdministrator().close();
  }
  

  public  static  AnsatAdministrator  getAnsatAdministrator()
  {
    return (getAssndbDataAdministrator().getAnsatAdministrator());
  }
  public  static  ProjektAdministrator  getProjektAdministrator()
  {
    return (getAssndbDataAdministrator().getProjektAdministrator());
  }
  public  static  ArbejderPaaAdministrator  getArbejderPaaAdministrator()
  {
    return (getAssndbDataAdministrator().getArbejderPaaAdministrator());
  }

  
}
  