import bjbupack.jdb.*;  
import java.sql.*;  
import java.util.*;  
/**  
	* Klassen til hndtering af Projekt-Objekter i relationel database  
  * @version  Januar 2002
	* @author	 	DBObjectAdministratorGenerator  
*/  

public class ProjektAdministrator	extends DBObjectAdministrator  
{  
	private 	int 	lastKey 	= 0; 		// gemmer til autonummerering 
	public	ProjektAdministrator (DBAdministrator		dbAdministrator,   
															String table)  
	{  
		super (dbAdministrator, table, "ID","SELECT * FROM "+table);  
		lastKey = getLastKey();		// gemmer til autonummerering  
	}  

	// get-metode med to ngler disables, da objekt er med enkeltngle
	public 	Object 	get 	(int key, int key2)
	{
		System.out.println("Fejl: der skal anvendes metode med eet nglerfelt");
		throw new UnsupportedOperationException();
	}

	// opretter et nyt object p databasen - implementer abstract  
	public 		boolean		add ( Object object )  
	{  
		Projekt 	projekt = (Projekt)object;  
		String sql 	= "INSERT INTO "+table  
								+ " ("  
								+ "  [ID]"  
								+ "  ,[Betegnelse]"  
								+ " ) VALUES "  
								+ " ("  
								+ "  "	+projekt.getID()			+""  
								+ ", '"	+projekt.getBetegnelse()			+"'"  
								+ " )";  
		return ( executeUpdate (sql) );  
	}  

	// opdaterer et eksisterede object p databasen - implementer abstract  
	public 		boolean		replace ( Object object )  
	{  
		Projekt 	projekt = (Projekt)object;  
		String sql	= "UPDATE "+table+" SET"  
								+ "  [Betegnelse]='"	+projekt.getBetegnelse()		+"'"  
								+ " WHERE [ID]="	+projekt.getID()		+""  
								;  
		return ( executeUpdate (sql) );  
	}  

	// sletter et object fra dabasen - implementer abstract  
	public 		boolean		remove ( Object object )  
	{  
		Projekt 	projekt = (Projekt)object;  
		String sql	= "DELETE * FROM "+table  
								+ " WHERE [ID]="	+projekt.getID()		+""  
								;  
		return ( executeUpdate (sql) );  
	}  

	// Konverter fra ResultSet til object - implementer abstract  
	protected Object	convertToObject (ResultSet resultSet)  
	{  
		try  
		{  
			Projekt 	projekt = new Projekt ( 	resultSet.getInt("ID"),  
																	 resultSet.getString("Betegnelse") 	); 
			return (projekt);  
		}  
		catch (SQLException e)		  
		{  
			System.out.println("Fejl ved convertToObject fra "+table);
			return (null);  
		}  
	}  

	// returner et nyt object - skal gemmes p databasen med add  
	public 		Projekt		newProjekt (String  betegnelse)  
	{  
		++lastKey;  
		Projekt projekt = new Projekt (lastKey, betegnelse);  
		return (projekt);  
	}  


}  
